import { ApolloLink, Observable, Observer, Operation, NextLink, FetchResult } from 'apollo-link';
export interface OperationQueueEntry {
    operation: Operation;
    forward: NextLink;
    observer: Observer<FetchResult>;
    subscription?: {
        unsubscribe: () => void;
    };
}
export default class SerializingLink extends ApolloLink {
    private opQueues;
    request(operation: Operation, forward: NextLink): Observable<{}>;
    private dequeue;
    private enqueue;
    private cancelOp;
    private startFirstOpIfNotStarted;
}
